<template>
    <div class="horizontal-valve">
        <slot></slot>
        <div :style="{ width: width, height: '1.6rem' }" class="position-relative font-weight-normal">
            <div v-if="labelTop"
                 :class="{ 'center-x': position == 'center'}"
                 :style="[{'font-size': fontSize}, position == 'right' ? {'right': '-10%'} : {}, position == 'left' ? {'left': '-15%'} : {}]"
                 class="position-absolute"
                 style="top: -80%"
                 v-html="labelTop">
            </div>

            <div v-if="labelBottom"
                 :class="{ 'center-x': position == 'center'}"
                 :style="[{'font-size': fontSize}, position == 'right' ? {'right': '-10%'} : {}, position == 'left' ? {'left': '-5%'} : {}]"
                 class="position-absolute"
                 style="bottom: -160%;"
                 v-html="labelBottom">
            </div>

            <div v-if="labelRight"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="left:90%"
                 v-html="labelRight">
            </div>

            <div v-if="labelLeft"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="right: 0"
                 v-html="labelLeft">
            </div>

            <svg v-if="position == 'center'" style="position: absolute; margin-top: 0.2rem; width: 3rem; left: 50%; transform: translateX(-50%)">
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 0,0, 0,16"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 28,0, 28,16"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 6,22 22,22"
                         stroke-width="1"
                />
            </svg>

            <svg v-if="position == 'left'" style="position: absolute; margin-top: 0.2rem; width: 3rem; left: 0%; transform: translateX(-50%)">
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 0,0, 0,16"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 28,0, 28,16"
                         stroke-width="1"
                />

                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 6,22 22,22"
                         stroke-width="1"
                />
            </svg>
            <svg v-if="position == 'right'" style="position: absolute; margin-top: 0.2rem; width: 3rem; left: 100%; transform: translateX(-50%)">
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 0,0, 0,16"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 28,0, 28,16"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="14,8 6,22 22,22"
                         stroke-width="1"
                />
            </svg>
            <svg height="100%" width="100%" xmlns="http://www.w3.org/2000/svg">
                <rect :class="{'rect-default' : !lineColor}"
                      :fill="lineColor ? lineColor : null"
                      :width="parseFloat(width) * 10"
                      height="3"
                      x="0"
                      y="6.5">
                </rect>
            </svg>
        </div>
    </div>
</template>

<script>
export default {
    name: 'three-way-horizontal-valve-component',
    props: {
        labelTop: {
            type: String,
        },
        labelBottom: {
            type: String,
        },
        labelRight: {
            type: String,
        },
        labelLeft: {
            type: String,
        },
        width: {
            type: [Number, String],
            default: '8rem'
        },
        height: {
            type: [Number, String],
        },
        status: {
            type: String,
            default: 'on'
        },
        fontSize: {
            type: String,
            default: '1.2rem'
        },
        position: {
            type: String,
            default: 'center'
        },
        lineColor: {
            type: String,
        },
        strokeColor: {
            type: String
        }
    },
    computed: {
        fillClass: function () {
            if (this.status === 'on') {
                return 'fill-on'
            }

            if (this.status === 'trip') {
                return 'fill-trip'
            }

            return 'fill-off'
        },
    }
}
</script>
